//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrGold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1 0.85
#property indicator_level2 0.50
#property indicator_level3 0.15
#property indicator_levelcolor DimGray
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame   = PERIOD_CURRENT; // Time frame to use
extern double             Gama1       = 0.60;           // First laguerre rsi gama
extern ENUM_APPLIED_PRICE Price1      = PRICE_CLOSE;    // First laguerre rsi price
extern int                Smooth1     = 2;              // First laguerre rsi smooth period
extern double             Gama2       = 0.80;           // First laguerre rsi gama
extern ENUM_APPLIED_PRICE Price2      = PRICE_CLOSE;    // First laguerre rsi price
extern int                Smooth2     = 2;              // First laguerre rsi smooth period
extern double             Gama3       = 0.50;           // First laguerre rsi gama
extern ENUM_APPLIED_PRICE Price3      = PRICE_CLOSE;    // First laguerre rsi price
extern int                Smooth3     = 0;              // First laguerre rsi smooth period
extern bool               Interpolate = true;           // Interpolate in multi time frame mode?


double lag1[],lag2[],lag3[];
string indicatorFileName;
bool   returnBars;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,lag1);
   SetIndexBuffer(1,lag2);
   SetIndexBuffer(2,lag3);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame==-99);
      TimeFrame         = MathMax(TimeFrame,_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" Laguerre rsi ("+(string)Gama1+","+(string)Smooth1+")  ("+
                                                                        (string)Gama2+","+(string)Smooth2+")  ("+
                                                                        (string)Gama3+","+(string)Smooth3+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);
            if (returnBars) { lag1[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != _Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  lag1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Gama1,Price1,Smooth1,Gama2,Price2,Smooth2,Gama3,Price3,Smooth3,0,y);
                  lag2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Gama1,Price1,Smooth1,Gama2,Price2,Smooth2,Gama3,Price3,Smooth3,1,y);
                  lag3[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Gama1,Price1,Smooth1,Gama2,Price2,Smooth2,Gama3,Price3,Smooth3,2,y);
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  int n,k; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                     for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                     {
                           lag1[i+k] = lag1[i] + (lag1[i+n] - lag1[i]) * k/n;
                           lag2[i+k] = lag2[i] + (lag2[i+n] - lag2[i]) * k/n;
                           lag3[i+k] = lag3[i] + (lag3[i+n] - lag3[i]) * k/n;
                     }                           
               }
               return(0);                  
            }

   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0 ; i--)
   {
      lag1[i] = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price1,i),Gama1,Smooth1,i,0);
      lag2[i] = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price2,i),Gama2,Smooth2,i,1);
      lag3[i] = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price3,i),Gama3,Smooth3,i,2);
   }      
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workLag[][15];
double LaGuerre(double price, double gamma, int smooth, int i, int instanceNo=0)
{
   if (ArrayRange(workLag,0)!=Bars) ArrayResize(workLag,Bars); i=Bars-i-1; instanceNo*=5;

   //
   //
   //
   //
   //
      
	double CU  = 0.00;
	double CD  = 0.00;
	double avg = 0;
   if (i==0) { for (int k=0; k<4; k++) workLag[i][instanceNo+k] = price; }
   else
   {
      workLag[i][instanceNo+0] = (1.0 - gamma)*price                                          + gamma*workLag[i-1][instanceNo+0];
	   workLag[i][instanceNo+1] = -gamma*workLag[i][instanceNo+0] + workLag[i-1][instanceNo+0] + gamma*workLag[i-1][instanceNo+1];
	   workLag[i][instanceNo+2] = -gamma*workLag[i][instanceNo+1] + workLag[i-1][instanceNo+1] + gamma*workLag[i-1][instanceNo+2];
	   workLag[i][instanceNo+3] = -gamma*workLag[i][instanceNo+2] + workLag[i-1][instanceNo+2] + gamma*workLag[i-1][instanceNo+3];

      //
      //
      //
      //
      //
   
	   if (workLag[i][instanceNo+0] >= workLag[i][instanceNo+1])
      			CU = workLag[i][instanceNo+0] - workLag[i][instanceNo+1];
	   else	   CD = workLag[i][instanceNo+1] - workLag[i][instanceNo+0];
	   if (workLag[i][instanceNo+1] >= workLag[i][instanceNo+2])
      			CU = CU + workLag[i][instanceNo+1] - workLag[i][instanceNo+2];
	   else	   CD = CD + workLag[i][instanceNo+2] - workLag[i][instanceNo+1];
	   if (workLag[i][instanceNo+2] >= workLag[i][instanceNo+3])
   			   CU = CU + workLag[i][instanceNo+2] - workLag[i][instanceNo+3];
   	else	   CD = CD + workLag[i][instanceNo+3] - workLag[i][instanceNo+2];
      if (CU + CD != 0) 
            workLag[i][instanceNo+4] = CU / (CU + CD) ;
      else  workLag[i][instanceNo+4] = 0;
      avg = workLag[i][instanceNo+4]; for (int k=1; k<smooth && (i-k)>=0; k++) avg += workLag[i-k][instanceNo+4]; avg /= MathMax(smooth,1);
   }      

   //
   //
   //
   //
   //

   return(avg);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}